Index: .checkstyle
===================================================================
RCS file: .checkstyle
diff -N .checkstyle
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ .checkstyle	1 Jan 1970 00:00:00 -0000
@@ -0,0 +1,7 @@
+<?xml version="1.0" encoding="UTF-8"?>
+
+<fileset-config file-format-version="1.2.0" simple-config="true">
+  <fileset name="all" enabled="true" check-config-name="OpenCms" local="false">
+    <file-match-pattern match-pattern="." include-pattern="true"/>
+  </fileset>
+</fileset-config>
Index: .classpath
===================================================================
RCS file: .classpath
diff -N .classpath
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ .classpath	1 Jan 1970 00:00:00 -0000
@@ -0,0 +1,61 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<classpath>
+	<classpathentry kind="src" path="src"/>
+	<classpathentry kind="src" path="src-modules"/>
+	<classpathentry kind="src" path="src-components"/>
+	<classpathentry kind="src" path="src-setup"/>
+	<classpathentry excluding="data/**|org/opencms/util/ant/" kind="src" path="test"/>
+	<classpathentry kind="con" path="org.eclipse.jdt.launching.JRE_CONTAINER"/>
+	<classpathentry kind="lib" path="modules/org.opencms.frontend.layoutpage/resources/system/modules/org.opencms.frontend.layoutpage/lib/freemarker-2.3.6.jar"/>
+	<classpathentry kind="lib" path="lib/compile/ant.jar"/>
+	<classpathentry kind="lib" path="lib/compile/ant-contrib-1.0b1.jar"/>
+	<classpathentry kind="lib" path="lib/compile/ant-opencms-1.1.jar"/>
+	<classpathentry kind="lib" path="lib/compile/jsp-api.jar"/>
+	<classpathentry kind="lib" path="lib/compile/junit-3-8-1.jar"/>
+	<classpathentry kind="lib" path="lib/compile/servlet-api.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/alkacon-diff-0.9.2.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/commons-codec-1.3.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/commons-dbcp-1.2.2.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/commons-digester-1.8.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/dom4j-1.6.1.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/htmlparser-1.6-20060610.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/jakarta-oro-2.0.8.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/jstl-1.1.2.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/jug-lgpl-2.0.0.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/PDFBox-0.7.2.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/poi-2.5.1-final-20040804.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/quartz-1.5.2.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/standard-1.1.2.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/tm-extractors-0.4.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/jtidy-8-svn-2006-05-21b.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/activation-1.1.1.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/alkacon-simapi-0.9.8.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/commons-beanutils-1.8.0.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/commons-collections-3.2.1.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/commons-fileupload-1.2.1.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/commons-httpclient-3.1.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/commons-io-1.4.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/commons-logging-1.1.1.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/jaxen-1.1.1.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/log4j-1.2.15.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/mail-1.4.1.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/xercesImpl-2.9.1.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/xml-apis-2.9.1.jar"/>
+	<classpathentry kind="lib" path="lib/compile/dumbster-1.6.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/lucene-analyzers-2.4.1.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/lucene-core-2.4.1.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/lucene-highlighter-2.4.1.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/lucene-queries-2.4.1.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/lucene-snowball-2.4.1.jar"/>
+	<classpathentry kind="lib" path="modules/org.opencms.frontend.templateone.form/resources/system/modules/org.opencms.frontend.templateone.form/lib/jcaptcha-1.0-all.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/commons-pool-1.5.4.jar"/>
+	<classpathentry kind="lib" path="webapp/setup/database/as400/jt400.jar"/>
+	<classpathentry kind="lib" path="webapp/setup/database/db2/db2jcc_v9.jar"/>
+	<classpathentry kind="lib" path="webapp/setup/database/hsqldb/hsqldb-1.8.0.8.jar"/>
+	<classpathentry kind="lib" path="webapp/setup/database/mssql/mssql-jtds-1.2.jar"/>
+	<classpathentry kind="lib" path="webapp/setup/database/mysql_41/mysql-connector-java-5.0.7-bin.jar"/>
+	<classpathentry kind="lib" path="webapp/setup/database/oracle/ojdbc14-10.2.0.3.jar"/>
+	<classpathentry kind="lib" path="webapp/setup/database/postgresql/postgresql-8.3-603.jdbc3.jar"/>
+	<classpathentry kind="lib" path="lib/runtime/commons-email-1.2.jar"/>
+	<classpathentry kind="output" path="bin"/>
+</classpath>
Index: .project
===================================================================
RCS file: .project
diff -N .project
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ .project	1 Jan 1970 00:00:00 -0000
@@ -0,0 +1,29 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<projectDescription>
+	<name>opencms-7.5.3</name>
+	<comment></comment>
+	<projects>
+	</projects>
+	<buildSpec>
+		<buildCommand>
+			<name>org.eclipse.jdt.core.javabuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+		<buildCommand>
+			<name>com.atlassw.tools.eclipse.checkstyle.CheckstyleBuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+		<buildCommand>
+			<name>net.sf.eclipsecs.core.CheckstyleBuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+	</buildSpec>
+	<natures>
+		<nature>org.eclipse.jdt.core.javanature</nature>
+		<nature>com.atlassw.tools.eclipse.checkstyle.CheckstyleNature</nature>
+		<nature>net.sf.eclipsecs.core.CheckstyleNature</nature>
+	</natures>
+</projectDescription>
Index: .settings/org.eclipse.jdt.core.prefs
===================================================================
RCS file: .settings/org.eclipse.jdt.core.prefs
diff -N .settings/org.eclipse.jdt.core.prefs
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ .settings/org.eclipse.jdt.core.prefs	1 Jan 1970 00:00:00 -0000
@@ -0,0 +1,70 @@
+#Thu Jan 07 19:55:34 CET 2010
+eclipse.preferences.version=1
+org.eclipse.jdt.core.compiler.codegen.inlineJsrBytecode=enabled
+org.eclipse.jdt.core.compiler.codegen.targetPlatform=1.5
+org.eclipse.jdt.core.compiler.codegen.unusedLocal=preserve
+org.eclipse.jdt.core.compiler.compliance=1.5
+org.eclipse.jdt.core.compiler.debug.lineNumber=generate
+org.eclipse.jdt.core.compiler.debug.localVariable=generate
+org.eclipse.jdt.core.compiler.debug.sourceFile=generate
+org.eclipse.jdt.core.compiler.problem.annotationSuperInterface=warning
+org.eclipse.jdt.core.compiler.problem.assertIdentifier=error
+org.eclipse.jdt.core.compiler.problem.autoboxing=warning
+org.eclipse.jdt.core.compiler.problem.deprecation=warning
+org.eclipse.jdt.core.compiler.problem.deprecationInDeprecatedCode=disabled
+org.eclipse.jdt.core.compiler.problem.deprecationWhenOverridingDeprecatedMethod=enabled
+org.eclipse.jdt.core.compiler.problem.discouragedReference=warning
+org.eclipse.jdt.core.compiler.problem.emptyStatement=warning
+org.eclipse.jdt.core.compiler.problem.enumIdentifier=error
+org.eclipse.jdt.core.compiler.problem.fallthroughCase=warning
+org.eclipse.jdt.core.compiler.problem.fatalOptionalError=enabled
+org.eclipse.jdt.core.compiler.problem.fieldHiding=warning
+org.eclipse.jdt.core.compiler.problem.finalParameterBound=warning
+org.eclipse.jdt.core.compiler.problem.finallyBlockNotCompletingNormally=warning
+org.eclipse.jdt.core.compiler.problem.forbiddenReference=error
+org.eclipse.jdt.core.compiler.problem.hiddenCatchBlock=warning
+org.eclipse.jdt.core.compiler.problem.incompatibleNonInheritedInterfaceMethod=warning
+org.eclipse.jdt.core.compiler.problem.incompleteEnumSwitch=warning
+org.eclipse.jdt.core.compiler.problem.indirectStaticAccess=warning
+org.eclipse.jdt.core.compiler.problem.localVariableHiding=warning
+org.eclipse.jdt.core.compiler.problem.methodWithConstructorName=warning
+org.eclipse.jdt.core.compiler.problem.missingDeprecatedAnnotation=warning
+org.eclipse.jdt.core.compiler.problem.missingOverrideAnnotation=warning
+org.eclipse.jdt.core.compiler.problem.missingSerialVersion=warning
+org.eclipse.jdt.core.compiler.problem.noEffectAssignment=warning
+org.eclipse.jdt.core.compiler.problem.noImplicitStringConversion=warning
+org.eclipse.jdt.core.compiler.problem.nonExternalizedStringLiteral=ignore
+org.eclipse.jdt.core.compiler.problem.nullReference=warning
+org.eclipse.jdt.core.compiler.problem.overridingPackageDefaultMethod=warning
+org.eclipse.jdt.core.compiler.problem.parameterAssignment=ignore
+org.eclipse.jdt.core.compiler.problem.possibleAccidentalBooleanAssignment=warning
+org.eclipse.jdt.core.compiler.problem.potentialNullReference=warning
+org.eclipse.jdt.core.compiler.problem.rawTypeReference=warning
+org.eclipse.jdt.core.compiler.problem.redundantNullCheck=warning
+org.eclipse.jdt.core.compiler.problem.redundantSuperinterface=warning
+org.eclipse.jdt.core.compiler.problem.specialParameterHidingField=enabled
+org.eclipse.jdt.core.compiler.problem.staticAccessReceiver=warning
+org.eclipse.jdt.core.compiler.problem.suppressWarnings=enabled
+org.eclipse.jdt.core.compiler.problem.syntheticAccessEmulation=warning
+org.eclipse.jdt.core.compiler.problem.typeParameterHiding=warning
+org.eclipse.jdt.core.compiler.problem.uncheckedTypeOperation=warning
+org.eclipse.jdt.core.compiler.problem.undocumentedEmptyBlock=warning
+org.eclipse.jdt.core.compiler.problem.unhandledWarningToken=warning
+org.eclipse.jdt.core.compiler.problem.unnecessaryElse=ignore
+org.eclipse.jdt.core.compiler.problem.unnecessaryTypeCheck=warning
+org.eclipse.jdt.core.compiler.problem.unqualifiedFieldAccess=ignore
+org.eclipse.jdt.core.compiler.problem.unusedDeclaredThrownException=warning
+org.eclipse.jdt.core.compiler.problem.unusedDeclaredThrownExceptionExemptExceptionAndThrowable=enabled
+org.eclipse.jdt.core.compiler.problem.unusedDeclaredThrownExceptionIncludeDocCommentReference=disabled
+org.eclipse.jdt.core.compiler.problem.unusedDeclaredThrownExceptionWhenOverriding=enabled
+org.eclipse.jdt.core.compiler.problem.unusedImport=warning
+org.eclipse.jdt.core.compiler.problem.unusedLabel=warning
+org.eclipse.jdt.core.compiler.problem.unusedLocal=warning
+org.eclipse.jdt.core.compiler.problem.unusedParameter=warning
+org.eclipse.jdt.core.compiler.problem.unusedParameterIncludeDocCommentReference=enabled
+org.eclipse.jdt.core.compiler.problem.unusedParameterWhenImplementingAbstract=disabled
+org.eclipse.jdt.core.compiler.problem.unusedParameterWhenOverridingConcrete=disabled
+org.eclipse.jdt.core.compiler.problem.unusedPrivateMember=warning
+org.eclipse.jdt.core.compiler.problem.unusedWarningToken=warning
+org.eclipse.jdt.core.compiler.problem.varargsArgumentNeedCast=warning
+org.eclipse.jdt.core.compiler.source=1.5
Index: .settings/org.eclipse.jdt.ui.prefs
===================================================================
RCS file: .settings/org.eclipse.jdt.ui.prefs
diff -N .settings/org.eclipse.jdt.ui.prefs
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ .settings/org.eclipse.jdt.ui.prefs	1 Jan 1970 00:00:00 -0000
@@ -0,0 +1,9 @@
+#Thu Jan 07 19:56:06 CET 2010
+cleanup_settings_version=2
+eclipse.preferences.version=1
+formatter_settings_version=11
+internal.default.compliance=default
+org.eclipse.jdt.ui.ignorelowercasenames=true
+org.eclipse.jdt.ui.importorder=com.alkacon;de.alkacon;org.opencms;com.opencms;java;javax;org.apache;org;com;
+org.eclipse.jdt.ui.ondemandthreshold=99
+org.eclipse.jdt.ui.staticondemandthreshold=99
Index: install-nonpublic-libs.bat
===================================================================
RCS file: install-nonpublic-libs.bat
diff -N install-nonpublic-libs.bat
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ install-nonpublic-libs.bat	1 Jan 1970 00:00:00 -0000
@@ -0,0 +1,17 @@
+echo off
+echo Installing Non-Puplic Libraries to the local Maven-Repository....
+call mvn install:install-file -DgroupId=com.alkacon -DartifactId=alkacon-diff -Dversion=0.9.2 -Dpackaging=jar -Dfile=lib/runtime/alkacon-diff-0.9.2.jar
+call mvn install:install-file -DgroupId=com.alkacon -DartifactId=alkacon-simapi -Dversion=0.9.8 -Dpackaging=jar -Dfile=lib/runtime/alkacon-simapi-0.9.8.jar
+
+
+echo Installing ibm.as400-Driver to the local Maven-Repository....
+call mvn install:install-file -DgroupId=com.ibm.as400 -DartifactId=jt400 -Dversion=6.0 -Dpackaging=jar -Dfile=webapp/setup/database/as400/jt400.jar
+
+echo Installing ibm.db2-Driver to the local Maven-Repository....
+call mvn install:install-file -DgroupId=com.ibm.db2.jcc -DartifactId=db2jcc -Dversion=V9 -Dpackaging=jar -Dfile=webapp/setup/database/db2/db2jcc_v9.jar
+call mvn install:install-file -DgroupId=com.ibm.db2.jcc -DartifactId=db2jcc_license_cu -Dversion=V9 -Dpackaging=jar -Dfile=webapp/setup/database/db2/db2jcc_license_cu.jar
+
+echo Installing oracle-Driver to the local Maven-Repository....
+call mvn install:install-file -DgroupId=com.oracle -DartifactId=ojdbc14 -Dversion=10.2.0.3 -Dpackaging=jar -Dfile=webapp/setup/database/oracle/ojdbc14-10.2.0.3.jar
+
+pause
Index: maven-deploy-init-all.bat
===================================================================
RCS file: maven-deploy-init-all.bat
diff -N maven-deploy-init-all.bat
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ maven-deploy-init-all.bat	1 Jan 1970 00:00:00 -0000
@@ -0,0 +1,7 @@
+echo off
+call set ANT_OPTS=-Xms128m -Xmx512m -XX:PermSize=128m -XX:MaxPermSize=256m
+call echo ANT_OPTS: %ANT_OPTS%
+call set MAVEN_OPTS=-Xms128m -Xmx512m -XX:PermSize=128m -XX:MaxPermSize=256m
+call echo MAVEN_OPTS: %MAVEN_OPTS%
+call ant maven-deploy-init-all
+pause
Index: maven-deploy-with-new-modules.bat
===================================================================
RCS file: maven-deploy-with-new-modules.bat
diff -N maven-deploy-with-new-modules.bat
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ maven-deploy-with-new-modules.bat	1 Jan 1970 00:00:00 -0000
@@ -0,0 +1,7 @@
+echo off
+call set ANT_OPTS=-Xms128m -Xmx512m -XX:PermSize=128m -XX:MaxPermSize=256m
+call echo ANT_OPTS: %ANT_OPTS%
+call set MAVEN_OPTS=-Xms128m -Xmx512m -XX:PermSize=128m -XX:MaxPermSize=256m
+call echo MAVEN_OPTS: %MAVEN_OPTS%
+call ant clean maven-deploy-with-new-modules
+pause
Index: maven-install-init-all.bat
===================================================================
RCS file: maven-install-init-all.bat
diff -N maven-install-init-all.bat
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ maven-install-init-all.bat	1 Jan 1970 00:00:00 -0000
@@ -0,0 +1,7 @@
+echo off
+call set ANT_OPTS=-Xms128m -Xmx512m -XX:PermSize=128m -XX:MaxPermSize=256m
+call echo ANT_OPTS: %ANT_OPTS%
+call set MAVEN_OPTS=-Xms128m -Xmx512m -XX:PermSize=128m -XX:MaxPermSize=256m
+call echo MAVEN_OPTS: %MAVEN_OPTS%
+call ant maven-install-init-all
+pause
Index: maven-install-with-new-modules.bat
===================================================================
RCS file: maven-install-with-new-modules.bat
diff -N maven-install-with-new-modules.bat
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ maven-install-with-new-modules.bat	1 Jan 1970 00:00:00 -0000
@@ -0,0 +1,7 @@
+echo off
+call set ANT_OPTS=-Xms128m -Xmx512m -XX:PermSize=128m -XX:MaxPermSize=256m
+call echo ANT_OPTS: %ANT_OPTS%
+call set MAVEN_OPTS=-Xms128m -Xmx512m -XX:PermSize=128m -XX:MaxPermSize=256m
+call echo MAVEN_OPTS: %MAVEN_OPTS%
+call ant maven-install-with-new-modules
+pause
Index: modules/maven-install.bat
===================================================================
RCS file: modules/maven-install.bat
diff -N modules/maven-install.bat
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ modules/maven-install.bat	1 Jan 1970 00:00:00 -0000
@@ -0,0 +1,5 @@
+echo off
+call set ANT_OPTS=-Xms128m -Xmx512m -XX:PermSize=128m -XX:MaxPermSize=256m
+call echo ANT_OPTS: %ANT_OPTS%
+call ant maven-install
+pause
Index: modules/org.opencms.editors/resources/system/workplace/editors/xmlcontent/edit.js
===================================================================
RCS file: /usr/local/cvs/opencms/modules/org.opencms.editors/resources/system/workplace/editors/xmlcontent/edit.js,v
retrieving revision 1.16
diff -u -r1.16 edit.js
--- modules/org.opencms.editors/resources/system/workplace/editors/xmlcontent/edit.js	18 Jan 2010 10:04:29 -0000	1.16
+++ modules/org.opencms.editors/resources/system/workplace/editors/xmlcontent/edit.js	24 Aug 2010 16:43:27 -0000
@@ -190,14 +190,88 @@
 }
 
 // add an optional element to the currently edited content
-function addElement(elemName, insertAfter) {
+function addElement(elemName, insertAfter, choiceList) {
 	setLastPosition();
 	var _form = document.EDITOR;
 	_form.elementname.value = elemName;
 	_form.elementindex.value = insertAfter;
+	if (choiceList.length == 0){
+		buttonAction(5);
+	} else if (choiceList.length == 1){
+		addChoiceElement(choiceList[0].Name);
+	} else {
+		// more than one element
+		showChoiceSelection(choiceList);
+	}
+}
+
+function addChoiceElement(elemName) {
+	var _form = document.EDITOR;
+	_form.choiceelementname.value = elemName;
 	buttonAction(5);
 }
 
+// shows the possible SubElements for a Choice-NestedContentType
+function showChoiceSelection(choiceList) {
+
+    // get Choice element
+    var choiceOverlay = document.getElementById("CHOICE_OVERLAY");
+    var choiceSelectElem = document.getElementById("CHOICE_SELECT");
+    var choiceSelectLinksElem = document.getElementById("CHOICE_SELECT_LINKS");
+
+    // create the button row HTML
+    var i = 0;
+    var linkList ="";
+    for (i=0; i < choiceList.length; i++){
+        if (i > 0){
+            linkList += "<br />";
+        }
+        linkList += "<a href=\"javascript:addChoiceElement(&quot;" + choiceList[i].Name + "&quot;);\" >";
+        linkList += choiceList[i].Label;
+        linkList += "</a>";
+        if (choiceList[i].Help){
+	        linkList += " (";
+	        linkList += choiceList[i].Help;
+	        linkList += ")";
+        }
+    }
+
+
+    // set the created HTML into the ModalBox
+    choiceSelectLinksElem.innerHTML = linkList;
+
+    // arrange the Modal-Box
+    var height = document.body.clientHeight/2;
+    var width = document.body.clientWidth/2;
+    choiceSelectElem.style.height = height + 'px';
+    choiceSelectElem.style.width = width + 'px';
+    choiceSelectLinksElem.style.height = height + 'px';
+    choiceSelectLinksElem.style.width = width + 'px';
+	choiceSelectElem.style.top  = document.body.scrollTop+(document.body.clientHeight - height)/2;
+	choiceSelectElem.style.left  = document.body.scrollLeft+(document.body.clientWidth - width)/2;
+
+    // show the Modal-Box
+    choiceSelectElem.style.display = "block";
+
+    // show the Gay Background
+	choiceOverlay.style.height = document.body.scrollHeight + 'px';
+	choiceOverlay.style.width = document.body.scrollWidth + 'px';
+    choiceOverlay.style.display = "block";
+
+}
+
+
+function closeChoiceSelection() {
+	var _form = document.EDITOR;
+	// reset the Data
+	_form.elementname.value = "";
+	_form.elementindex.value = "";
+	_form.choiceelementname.value = "";
+	// close the Modal-Box
+    document.getElementById('CHOICE_SELECT').style.display ='none';
+    document.getElementById('CHOICE_OVERLAY').style.display = 'none';
+}
+
 // move an element in currently edited content
 function moveElement(elemName, index, direction) {
 	setLastPosition();
@@ -307,7 +381,7 @@
 }
 
 // shows the element operation buttons
-function showElementButtons(elementName, elementIndex, showRemove, showUp, showDown, showAdd) {
+function showElementButtons(elementName, elementIndex, showRemove, showUp, showDown, showAdd, choiceList) {
 	var elemId = elementName + "." + elementIndex;
 	if (oldEditorButtons != null && oldEditorButtons != elemId) {
 		// close eventually open element buttons
@@ -342,7 +416,7 @@
 
 	// add element button
 	if (showAdd) {
-		buttons += button("javascript:addElement('" + elementName + "', " + elementIndex + ")", null, "new", LANG_BT_ADD, buttonStyle);
+		buttons += button("javascript:addElement('" + elementName + "', " + elementIndex + ", " + choiceList + ")", null, "new", LANG_BT_ADD, buttonStyle);
 	} else {
 		buttons += button(null, null, "new_in", LANG_BT_ADD, buttonStyle);
 	}
Index: modules/org.opencms.editors/resources/system/workplace/editors/xmlcontent/editor_form.jsp
===================================================================
RCS file: /usr/local/cvs/opencms/modules/org.opencms.editors/resources/system/workplace/editors/xmlcontent/editor_form.jsp,v
retrieving revision 1.15
diff -u -r1.15 editor_form.jsp
--- modules/org.opencms.editors/resources/system/workplace/editors/xmlcontent/editor_form.jsp	9 Jun 2009 12:21:36 -0000	1.15
+++ modules/org.opencms.editors/resources/system/workplace/editors/xmlcontent/editor_form.jsp	24 Aug 2010 16:43:27 -0000
@@ -298,9 +298,80 @@
 //-->
 </script>
 
+<style>
+#CHOICE_OVERLAY
+{
+    display:none;
+    position:absolute;
+    top:0;
+    left:0;
+    z-index:5000;   
+    background-color:#000;
+    -moz-opacity: 0.5;
+    opacity:.50;
+    filter: alpha(opacity=50);
+}
+
+#CHOICE_SELECT{
+    display:none;
+    position: absolute;
+    z-index:9999;
+    background-color:#d6d3ce;
+    border-color:white #848484 #848484 white;
+    border-style:solid;
+    border-width:2px;
+  
+}
+#CHOICE_HEADER
+{
+	background-color:#08246b;
+	width:100%;
+	float:left;
+}
+
+#CHOICE_HEADER_L
+{
+float:left;
+color:white;
+font-weight:bold;
+font-size:12px;
+padding:2px 0 0 4px;
+
+}
+#CHOICE_HEADER_R
+{
+float:right;
+background-color:#d6d3ce;
+}
+
+#CHOICE_SELECT_LINKS
+
+{
+background-color:#d6d3ce;
+overflow:auto;
+float:left;
+border-color:white #848484 #848484 white;
+border-style:solid;
+border-width:1px;
+margin:20px 0 0 20px;
+padding:20px 0 0 20px;
+width:90% !important;
+height:80% !important;
+}
+</style>
+
 </head>
 <body class="buttons-head" unselectable="on" onload="init();" onunload="exitEditor();">
 
+<div id="CHOICE_OVERLAY" name="CHOICE_OVERLAY"></div>
+<div id="CHOICE_SELECT" name="CHOICE_SELECT" >
+<div id="CHOICE_HEADER" style="">
+<div id="CHOICE_HEADER_L">Modal Window</div>
+<div id="CHOICE_HEADER_R"><a href="javascript:;" onClick="closeChoiceSelection();"><img src="<%=wp.getSkinUri()%>buttons/exit.png" alt="close" width="20" height="20" border="0"/></a></div>
+</div>
+<div id="CHOICE_SELECT_LINKS" name="CHOICE_SELECT_LINKS" ></div>
+</div>
+
 <form name="EDITOR" id="EDITOR" method="post" action="<%= wp.getJsp().link(CmsEditor.PATH_EDITORS + "xmlcontent/editor_form.jsp") %>">
 <input type="hidden" name="<%= CmsDialog.PARAM_ACTION %>" value="<%= wp.getParamAction() %>">
 <input type="hidden" name="<%= CmsDialog.PARAM_RESOURCE %>" value="<%= wp.getParamResource() %>">
@@ -314,6 +385,7 @@
 <input type="hidden" name="<%= CmsEditor.PARAM_MODIFIED %>" value="<%= wp.getParamModified() %>">
 <input type="hidden" name="<%= CmsXmlContentEditor.PARAM_ELEMENTINDEX %>" value="">
 <input type="hidden" name="<%= CmsXmlContentEditor.PARAM_ELEMENTNAME %>" value="">
+<input type="hidden" name="<%= CmsXmlContentEditor.PARAM_CHOICEELEMENTNAME %>" value="">
  
 <%= wp.getXmlEditorForm() %>
 
Index: modules/org.opencms.editors/resources/system/workplace/resources/editors/directedit/jq_edit.js
===================================================================
RCS file: /usr/local/cvs/opencms/modules/org.opencms.editors/resources/system/workplace/resources/editors/directedit/jq_edit.js,v
retrieving revision 1.2
diff -u -r1.2 jq_edit.js
--- modules/org.opencms.editors/resources/system/workplace/resources/editors/directedit/jq_edit.js	25 Mar 2008 09:12:44 -0000	1.2
+++ modules/org.opencms.editors/resources/system/workplace/resources/editors/directedit/jq_edit.js	24 Aug 2010 16:43:27 -0000
@@ -161,6 +161,7 @@
 
 /** Function to set the position of the buttons to the correct position. **/
 var func_ocms_de_reposition = function() {
+  if(this.offsetParent) {
 	var offset = $(this).calcOcmsDeOffset();
     offset.left = offset.left + $(this).width() - $('#buttons_'+this.id).width();
     $('#buttons_'+this.id).css(offset);
@@ -169,6 +170,7 @@
      } else {
        $('#buttons_'+this.id).css('visibility', "hidden");
      }
+  }
 };
 
 /** Function submit the form after clicking the direct edit button. **/
Index: modules/org.opencms.workplace.explorer/resources/system/workplace/resources/commons/tree.js
===================================================================
RCS file: /usr/local/cvs/opencms/modules/org.opencms.workplace.explorer/resources/system/workplace/resources/commons/tree.js,v
retrieving revision 1.15
diff -u -r1.15 tree.js
--- modules/org.opencms.workplace.explorer/resources/system/workplace/resources/commons/tree.js	28 May 2010 10:55:27 -0000	1.15
+++ modules/org.opencms.workplace.explorer/resources/system/workplace/resources/commons/tree.js	24 Aug 2010 16:43:27 -0000
@@ -88,6 +88,7 @@
 var m_rootFolder = null;
 var m_sitePrefix = null;
 var m_treeType = null;
+var m_resourcetypeIds = null;
 
 function treeObject(){
     this.dfsToggleFound = false;
@@ -547,6 +548,14 @@
     }
 }
 
+function getResourcetypeIds() {
+    return m_resourcetypeIds;
+}
+
+function setResourcetypeIds(resourcetypeIds) {
+	m_resourcetypeIds = resourcetypeIds;
+}
+
 function setRootFolder(value) {
     m_rootFolder = value;
 }
@@ -574,6 +583,9 @@
     if (getTreeType()) {
         params += "&type=" + getTreeType();
     }
+    if (getResourcetypeIds()) {
+        params += "&resourcetypeIds=" + getResourcetypeIds();
+	}
     if (m_rootFolder) {
         nodeName = m_rootFolder + nodeName.substring(1);        
     }
@@ -638,9 +650,13 @@
     if (!isProjectAware()) {
         params += "&projectaware=false";
     }
-      if (getTreeType()) {
-            params += "&type=" + getTreeType();
-        }        
+    if (getTreeType()) {
+        params += "&type=" + getTreeType();
+    }
+    if (getResourcetypeIds()) {
+        params += "&resourcetypeIds=" + getResourcetypeIds();
+    }
+	
     var nodeNames = "";
     for (var i=0; i < nodeListToLoad.length; i++) {
         var node = nodeListToLoad[i];
Index: modules/org.opencms.workplace.explorer/resources/system/workplace/views/explorer/tree_fs.jsp
===================================================================
RCS file: /usr/local/cvs/opencms/modules/org.opencms.workplace.explorer/resources/system/workplace/views/explorer/tree_fs.jsp,v
retrieving revision 1.5
diff -u -r1.5 tree_fs.jsp
--- modules/org.opencms.workplace.explorer/resources/system/workplace/views/explorer/tree_fs.jsp	6 Jul 2007 09:52:13 -0000	1.5
+++ modules/org.opencms.workplace.explorer/resources/system/workplace/views/explorer/tree_fs.jsp	24 Aug 2010 16:43:27 -0000
@@ -30,6 +30,13 @@
 		params.append("=true");
 	}
 	
+	if (wp.getResourcetypeIds() != null) {
+		params.append("&");
+		params.append(CmsTree.PARAM_RESOURCETYPE_IDS);
+		params.append("=");
+		params.append(wp.getResourcetypeIds());
+	}
+	
 	String frameRows = "*,0";
 	String frameSiteSelector = "";
 	if (wp.showSiteSelector()) {
Index: modules/org.opencms.workplace.explorer/resources/system/workplace/views/explorer/tree_siteselector.jsp
===================================================================
RCS file: /usr/local/cvs/opencms/modules/org.opencms.workplace.explorer/resources/system/workplace/views/explorer/tree_siteselector.jsp,v
retrieving revision 1.5
diff -u -r1.5 tree_siteselector.jsp
--- modules/org.opencms.workplace.explorer/resources/system/workplace/views/explorer/tree_siteselector.jsp	9 Jun 2008 13:41:54 -0000	1.5
+++ modules/org.opencms.workplace.explorer/resources/system/workplace/views/explorer/tree_siteselector.jsp	24 Aug 2010 16:43:27 -0000
@@ -32,8 +32,9 @@
 <td>
 <form name="siteselect" method="post" action="tree_fs.jsp" target="_top">
 <input type="hidden" name="<%= CmsTree.PARAM_INCLUDEFILES %>" value="<%= wp.includeFiles() %>">
-<input type="hidden" name="<%= CmsTree.PARAM_TYPE %>" value="<%= wp.getTreeType() %>">
-<input type="hidden" name="<%= CmsTree.PARAM_SHOWSITESELECTOR %>" value="<%= wp.showSiteSelector() %>">
+<input type="hidden" name="<%= CmsTree.PARAM_TYPE %>" value="<%= wp.getTreeType() %>">
+<input type="hidden" name="<%= CmsTree.PARAM_SHOWSITESELECTOR %>" value="<%= wp.showSiteSelector() %>">
+<input type="hidden" name="<%= CmsTree.PARAM_RESOURCETYPE_IDS %>" value="<%= wp.getResourcetypeIds() %>">
 <input type="hidden" name="<%= CmsTree.PARAM_RESOURCE %>" value="/">
 <%= wp.getSiteSelector("name=\"treesite\" onchange=\"changeSite();\" style=\"width:250px;\"") %>
 </form>
Index: modules/org.opencms.workplace/resources/system/workplace/resources/components/widgets/fileselector.js
===================================================================
RCS file: /usr/local/cvs/opencms/modules/org.opencms.workplace/resources/system/workplace/resources/components/widgets/fileselector.js,v
retrieving revision 1.12
diff -u -r1.12 fileselector.js
--- modules/org.opencms.workplace/resources/system/workplace/resources/components/widgets/fileselector.js	5 Jun 2009 13:31:35 -0000	1.12
+++ modules/org.opencms.workplace/resources/system/workplace/resources/components/widgets/fileselector.js	24 Aug 2010 16:43:27 -0000
@@ -43,7 +43,7 @@
 var treeField = null;
 var treeDoc = null;
 
-function openTreeWin(formName, fieldName, curDoc, showSiteSelector, startSite, includeFiles, projectAware) {
+function openTreeWin(formName, fieldName, curDoc, showSiteSelector, startSite, includeFiles, projectAware, resourcetypeIds) {
 
 	if (includeFiles == null) {
 		includeFiles = true;
@@ -65,6 +65,10 @@
 		paramString += "&treesite=";
 		paramString += startSite;
 	}
+	
+	if (resourcetypeIds != null) {
+		paramString += "&resourcetypeIds="+ resourcetypeIds;
+	}
 
 	treewin = openWin(vr.contextPath + vr.workplacePath + "views/explorer/tree_fs.jsp" + paramString, "opencms", 300, 450);
 	treeForm = formName;
Index: src-setup/org/opencms/setup/CmsSetupBean.java
===================================================================
RCS file: /usr/local/cvs/opencms/src-setup/org/opencms/setup/CmsSetupBean.java,v
retrieving revision 1.13
diff -u -r1.13 CmsSetupBean.java
--- src-setup/org/opencms/setup/CmsSetupBean.java	18 Jan 2010 10:02:59 -0000	1.13
+++ src-setup/org/opencms/setup/CmsSetupBean.java	24 Aug 2010 16:43:28 -0000
@@ -1909,6 +1909,11 @@
                 // initialize the database name with the app name
                 if (CmsStringUtil.isNotEmptyOrWhitespaceOnly(request.getContextPath())) {
                     dbName = request.getContextPath().substring(1);
+                    // transform Maven default finalName "${artifactId}-${version}.war"
+                    // e.g.: "opencms-demo-7.5.2" -> "opencms_demo_7_5_2"
+                    // reason: e.g.: MySql cannot have '-', '.' in Database-Name.
+                    dbName = dbName.replace('-', '_');
+                    dbName = dbName.replace('.', '_');
                 }
                 if (provider.equals(ORACLE_PROVIDER)
                     || provider.equals(POSTGRESQL_PROVIDER)
